ilogit <-
function(model){
#### F. Guillaume Blanchet - Avril 2013
##########################################################################################
	#### Apply the inverse logit transformation (this approach is quicker than using binomial(link="logit")$linkinv)
	expMat<-exp(model)
	model.ilogit<-expMat/(1+expMat)
	
	### Correct for cases where  values in expMat are infinite
	infi<-is.infinite(expMat)
	if(any(infi)){
		model.ilogit[which(infi)]<-1
	}	
	return(model.ilogit)
}
