loglikelihood.formula <-
function(formula,paramX,data,likelihoodtype="logit",...,prior){
#### F. Guillaume Blanchet - Avril 2013
##########################################################################################
	regression<-parseformula(formula,paramX,data)
	y<-regression$y
	
	if(likelihoodtype=="logit"){
		#### Apply the inverse logit transformation and calculating log-likelihood
		model<-ilogit(regression$model)
		resFinal<-sum(log((model*y)+((1-model)*(1-y))))
	}
	if(likelihoodtype=="poisson"){
		model<-ilog(regression$model)
		resFinal<-sum(y*regression$model-model)
	}
	if(likelihoodtype=="normal"){
		resFinal<- -1/(2*prior) * sum((y-regression$model)^2)
	}

	return(resFinal)
}
