plot.communitySimul <-
function(x, ...){
### F. Guillaume Blanchet - Avril 2013
##########################################################################################
	if(length(x$param)==1){
		stop("This plot function should not be used for plotting predictions.")
	}
	nsp<-ncol(x$probMat)
	nsite<-nrow(x$probMat)
	
	par(mfrow=c(1,2))
	### Plot model
	plot(x$probMat[,1],col=rainbow(nsp)[1],type="l",ylim=range(x$probMat),las=1,xlab="sites",ylab="Occurrence probability",main="Occurrence probabilities of species")
	
	for(i in 2:nsp){
		lines(x$probMat[,i],col=rainbow(nsp)[i])
	}
	
	#===============
	### Plot samples
	#===============
	dataOcc<-as.matrix(ifelse(x$data$Y>0,1,0))
	image(1:nsite,1:nsp,dataOcc%*%diag(1:nsp),col=c(NA,rainbow(nsp)),xlab="Sites",ylab="Species occurrence",las=1)
}
