scamRandom.HMSCdata <-
function(data,start,priors,rotationVal,rotationVect,wParamRandom,wOuterParamRandom,wRandomCov,sdvalue,accept,likelihoodtype="logit",burning=TRUE,rotation=TRUE,iter,...){
#### F. Guillaume Blanchet - March 2014
##########################################################################################
	#========================
	#### Initiation of object
	#========================
	nparamRandom<-ncol(start$paramRandom)
	nsp<-ncol(data$Y)
	nsite<-nrow(data$Y)
	zero<-rep(0,nsp)
#	zero<-rowMeans(start$paramRandom)
	
	paramRandomCurrent<-start$paramRandom
	varCurrent<-start$RandomVar
	
	RandomCovCurrent<-matrix(start$RandomCommSp,nsp,nsp)
	diag(RandomCovCurrent)<-1
	RandomCovCurrent<-varCurrent*RandomCovCurrent
	logVarCurrent<--log(varCurrent)
	
	#=====================
	### Estimate RandomVar
	#=====================
	#### Calculate log-likelihood for the variance of Random
	likeCurrentRandomVar<-numeric()
	for(i in 1:nparamRandom){
		likeCurrentRandomVar[i]<-loglikelihood(mat=RandomCovCurrent,param=paramRandomCurrent[,i],means=zero,likelihoodtype="sigma")
	}
	
	#### Calculate log-likelihood for RandomCov
	likeCurrentRandomCov<-loglikelihood(mat=RandomCovCurrent,likelihoodtype="RandomCov")
	
if(TRUE){
	### Prior variance
	priorVarCurrent<--(logVarCurrent-priors$priorRandom[1])^2/(2*priors$priorRandom[2]^2)
	
	### Update VarCurrent 
	logVarNew<-logVarCurrent+rnorm(1,mean=0,sd=1)
#	logVarNew<-logVarCurrent+rnorm(1,mean=0,sd=sdvalue$sdvalueRandomCov)*wRandomCov
	priorVarNew<--(logVarNew-priors$priorRandom[1])^2/(2*priors$priorRandom[2]^2) 
	
	### Reconstruct RandomCov
	RandomCovNew<-matrix(start$RandomCommSp,nsp,nsp)
	diag(RandomCovNew)<-1
	varNew<-exp(logVarNew)
	RandomCovNew<-varNew*RandomCovNew

	#### Calculate log-likelihood for the new parameters of Random
	likeNewRandomVar<-numeric()
	for(i in 1:nparamRandom){
		likeNewRandomVar[i]<-loglikelihood(mat=RandomCovNew,param=paramRandomCurrent[,i],means=zero,likelihoodtype="sigma")
	}
	
	#### Calculate log-likelihood for new parameterization of RandomCov
	likeNewRandomCov<-loglikelihood(mat=RandomCovNew,likelihoodtype="RandomCov")
	
	### Accept ratio
	accept$acceptRandomCov[2]<-accept$acceptRandomCov[2]+1
	
	### Whether the new parameters are accepted or not
	if(runif(1) <= exp(sum(likeNewRandomVar)-sum(likeCurrentRandomVar)+nparamRandom*(likeNewRandomCov-likeCurrentRandomCov)+priorVarNew-priorVarCurrent)){
		### Accept ratio
		accept$acceptRandomCov[1]<-accept$acceptRandomCov[1]+1
		
		### Save the new parameters
		varCurrent<-varNew
		RandomCovCurrent<-RandomCovNew
		priorVarCurrent<-priorVarNew
		likeCurrentRandomVar<-likeNewRandomVar
		likeCurrentRandomCov<-likeNewRandomCov
	}
}


	#=========================
	### Estimate RandomCurrent
	#=========================
if(TRUE){
	#### Calculate log-likelihood for the parameters of Random
	likeCurrentParamRandom<-loglikelihood(data$Y,data$X,start$paramX,data$Random,start$paramRandom,likelihoodtype=likelihoodtype)
	
	### Update paramRandomCurrent
	for(i in 1:nsp){
		for(j in 1:nparamRandom){
			paramRandomNew<-paramRandomCurrent
#			paramRandomNew[i,]<-paramRandomNew[i,]+rnorm(1,mean=0,sd=sdvalue$sdvalueRandom[i,j])*sqrt(rotationVal[i,j])*rotationVect[,j,i]
			paramRandomNew[i,j]<-paramRandomNew[i,j]+rnorm(1,mean=0,sd=1)
			
			### Calculate log-likelihoods
			likeNewParamRandom<-loglikelihood(data$Y,data$X,start$paramX,data$Random,paramRandomNew,likelihoodtype=likelihoodtype)
			likeNewRandomVar<-loglikelihood(mat=RandomCovCurrent,param=paramRandomNew[,j],means=zero,likelihoodtype="sigma")
			
			### Accept ratio
			accept$acceptRandom[i,j,2]<-accept$acceptRandom[i,j,2]+1
			
			### Whether the new parameters are accepted or not
			if(runif(1) <= exp(likeNewParamRandom-likeCurrentParamRandom+likeNewRandomVar-likeCurrentRandomVar[j])){
				### Accept ratio
				accept$acceptRandom[i,j,1]<-accept$acceptRandom[i,j,1]+1
				
				### Save the new parameters
				paramRandomCurrent<-paramRandomNew
				likeCurrentParamRandom<-likeNewParamRandom
				likeCurrentRandomVar[j]<-likeNewRandomVar
			}
		}
	}
}

if(TRUE){
	if(burning){
		### Greediness during the adaptation period
		greedAdapt<-1+exp(-iter/500)
		
		### Calculate the accept ratios
#		acceptRatioRandom<-accept$acceptRandom[,,1]/accept$acceptRandom[,,2]
		acceptRatioRandomCov<-accept$acceptRandomCov[1]/accept$acceptRandomCov[2]
		
		### Adapt the standard deviations
#		sdvalue$sdvalueRandom<-sdvalue$sdvalueRandom*greedAdapt^(acceptRatioRandom-0.44)
		sdvalue$sdvalueRandomCov<-sdvalue$sdvalueRandomCov*greedAdapt^(acceptRatioRandomCov-0.44)
		
		### Weight the accept ratios
		wAccept<-1-0.1*exp(-iter/500) # w
#		accept$acceptRandom<-accept$acceptRandom*wAccept
		accept$acceptRandomCov<-accept$acceptRandomCov*wAccept
		
		### Weight the current parameters
#		wParamRandom<-wParamRandom+wAccept*paramRandomCurrent
		wRandomCov<-wRandomCov+wAccept*logVarCurrent
		
		### Weight the outer product of the current ParamX
#		for(j in 1:nsp){
#			wOuterParamRandom[,,j]<-wOuterParamRandom[,,j]+wAccept*outer(paramRandomCurrent[j,],paramRandomCurrent[j,])
#		}
#		if(rotation){
#			### Sum the weight
#			weight<-sum(1-0.1*exp(-(1:iter)/500))
#			for(j in 1:nsp){
#				### Construct a weighted covariance matrix
#				covMat<-(wOuterParamRandom[,,j]-outer(wParamRandom[j,],wParamRandom[j,])/weight)/(weight-1)+diag(sqrt(.Machine$double.eps),nparamRandom)
#				rotationBase<-eigen(covMat)
#				rotationVal[j,]<-rotationBase$values
#				rotationVect[,,j]<-rotationBase$vectors
#			}
#		}
		# * No rotation for RandomCov because the value considered is a scalar
	}
}
	#### Result object
	startNew<-list(paramRandom=paramRandomCurrent,
				   RandomVar=varCurrent)
	
	rotNew<-list(valuesRandom=rotationVal,
				 vectorsRandom=rotationVect,
				 wParamRandom=wParamRandom,
				 wOuterParamRandom=wOuterParamRandom,
				 wRandomCov=wRandomCov)
	
	res<-list(start=startNew,rotation=rotNew,sdvalue=sdvalue,accept=accept)
	
	return(res)
}
