\name{ilogit}
\alias{ilogit}
\alias{ilog}
\title{
Inverse link functions
}
\description{
These function calculate the inverse link functions. They should give exactly the same results as the \code{linkinv} functions attached to \code{\link{family}} objects. The main different is that they are faster.
}
\usage{
ilogit(model)
ilog(model)
}
\arguments{
  \item{model}{
Numeric vector constructed from the covariate and parameters of a model.
}
}
\details{
The mathematical definitions of the inverse link functions are presented below In these definition, M is the regression model for ewhich the inverse link was calculated.
	\tabular{ll}{
		\code{ilogit}
		\tab \eqn{\frac{e^M}{1+e^M}}{exp(M)/(1+exp(M))}
		\cr
		\code{ilog}
		\tab \eqn{e^M}{exp(M)}
	}
}
\value{
A numeric vector.
}

\author{
F. Guillaume Blanchet
}

\seealso{
\code{\link{loglikelihood}}
}
